//---------------------------------------------------------------------------

#ifndef zcryptH
#define zcryptH

#include "zvithdr.h"

// BITIS START
typedef int (*PLoadPQA)(char* );
typedef int (*PGetKeyPair)(char* , char*);
typedef char* (*PZvitEncryptMsg)(char* , char*, char*, int &/*MsgInLen*/, char* /*pIn*/);
typedef char* (*PZvitDecryptMsg)(char* , char*, char*, int &/*MsgInLen*/, char* /*pIn*/);
typedef int (*PLoadSignSBox)(char* );
typedef int (*PLoadCryptSBox)(char* );
typedef int (*PLoadRandSBox)(char* );
typedef bool (*PInitializeRndGenerator)(void);
// BITIS END
class TRawPacket;

typedef bool (*POnGetQwrHeader)( TRpgQwrHeader * );

#define SECRETKEY_LEN 32
#define PUBLICKEY_LEN 128

class TZvitCrypt
{
public:                                      
	__fastcall TZvitCrypt();
	virtual __fastcall ~TZvitCrypt();
        bool __fastcall InitCryptLib(void);
	virtual bool __fastcall Encrypt(AnsiString EDRPOU, TMemoryStream * File);
	virtual bool __fastcall Decrypt(TMemoryStream * File);

        virtual bool __fastcall AskCryptKeys(AnsiString Dir);
        virtual bool __fastcall AskDecryptRplKeys(AnsiString Dir);
        virtual bool __fastcall AskDecryptArcKeys(AnsiString Dir);
        virtual bool __fastcall AskDecryptPckKeys(AnsiString Dir);

	virtual bool __fastcall LoadSignKey(AnsiString FileName);
	virtual bool __fastcall LoadSign2Key(AnsiString FileName);
	virtual bool __fastcall LoadCryptKey(AnsiString FileName);
	virtual bool __fastcall LoadHashFiles(AnsiString Dir);
	//---------------------------------------------------------------------
private:
	AnsiString MailDir, TempDir;
	HMODULE HEncrypt;
	PLoadPQA LoadPQA;
	PLoadCryptSBox LoadCryptSBox;
	PLoadSignSBox LoadSignSBox;
	PLoadRandSBox LoadRandSBox;
	PZvitEncryptMsg ZvitEncryptMsg;
	PZvitDecryptMsg ZvitDecryptMsg;
	PInitializeRndGenerator InitializeRndGenerator;
public:
        //     (  )
        char SignKey[128]; int SignKeyLen;
        char SignKey2[128]; int SignKey2Len;
        char CryptKey[128]; int CryptKeyLen;

        char CryptSBX[512]; int CryptSBXLen;
        char SignSBX[512]; int SignSBXLen;
        char RandSBX[512]; int RandSBXLen;
        char PQAGFD[512]; int PQAGFDLen;

  POnGetQwrHeader OnGetQwrHeader;

  bool __fastcall EncryptPlt2Nal( TStream * pStream, TRpgQwrHeader * pQwrHeader );

  //-------------------------------------------------------------------------------
  //        -
  //-------------------------------------------------------------------------------
  bool __fastcall DecryptNalFromPlt( TStream * pStream, TRpgQwrHeader * pQwrHeader );

};

//---------------------------------------------------------------------------
#endif
