//---------------------------------------------------------------------------

#include <vcl.h>
#include <FileCtrl.hpp>
#pragma hdrstop

#include "ZCryptMain.h"
#include "ZCrypt.h"
//#include "Oem2ch.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TZCryptMainFrm *ZCryptMainFrm;

TZvitCrypt ZCrypt;
//---------------------------------------------------------------------------
__fastcall TZCryptMainFrm::TZCryptMainFrm(TComponent* Owner)
        : TForm(Owner)
{
  if(!ZCrypt.InitCryptLib())
  {
    ShowMessage("  ");
    //return;
  }
}
//---------------------------------------------------------------------------
AnsiString GetStartDirectory()
{
  char buf[MAX_PATH] = "";
  GetModuleFileName(0, buf, sizeof(buf));
  return ExtractFilePath(buf);
}

void __fastcall TZCryptMainFrm::EncryptBtnClick(TObject *Sender)
{ //
  if(!FileExists(SrcFile->Text))
  {
    ShowMessage("   "+SrcFile->Text);
    return;
  }
  
  AnsiString DirName = GetStartDirectory();
  TSelectDirOpts opts;
  if (!SelectDirectory(DirName, opts, 0))
  {
    ShowMessage("   !");
    return;
  }
  if(!ZCrypt.AskCryptKeys(DirName)) return;
  AnsiString IniFileName = DirName + "\\private_manager\\firm.ini";
  TStringList *FirmInfo = new TStringList;
  if(!FileExists(IniFileName))
  {
    ShowMessage("   "+IniFileName);
    return;
  }
  FirmInfo->LoadFromFile(IniFileName);
  AnsiString EDRPOU = FirmInfo->Strings[0];
  delete FirmInfo;
  TMemoryStream *CryptFile = new TMemoryStream;
  CryptFile->LoadFromFile(SrcFile->Text);
  if(!ZCrypt.Encrypt(EDRPOU, CryptFile)) return;
  CryptFile->SaveToFile(DstFile->Text);
  delete CryptFile;
  ::MessageBox(NULL, "  ","",
                        MB_OK|MB_ICONINFORMATION|MB_SYSTEMMODAL);
}
//---------------------------------------------------------------------------

void __fastcall TZCryptMainFrm::BtnSelFileClick(TObject *Sender)
{
  if(!OpenDialog1->Execute()) return;
  SrcFile->Text = OpenDialog1->FileName;
  DstFile->Text = SrcFile->Text;
}
//---------------------------------------------------------------------------

void __fastcall TZCryptMainFrm::BtnSelRPLClick(TObject *Sender)
{
  if(!OpenDialog1->Execute()) return;
  RPLFile->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TZCryptMainFrm::DecryptBtnClick(TObject *Sender)
{ //
  AnsiString DirName = GetStartDirectory();
  TSelectDirOpts opts;
  if (!SelectDirectory(DirName, opts, 0))
  {
    ShowMessage("   !");
    return;
  }
  if(!ZCrypt.AskDecryptRplKeys(DirName)) return;
  TMemoryStream *CRPLFile = new TMemoryStream;
  CRPLFile->LoadFromFile(RPLFile->Text);
  if(!ZCrypt.Decrypt(CRPLFile)) return;
  //CRPLFile->SaveToFile(DstFile->Text);
  RPLMemo->Lines->LoadFromStream(CRPLFile);
  AnsiString RPLText = RPLMemo->Lines->Text;
  OemToCharBuff(RPLText.c_str(),RPLText.c_str(), RPLText.Length());
  RPLMemo->Lines->Text = RPLText;
  delete CRPLFile;
}
//---------------------------------------------------------------------------

void __fastcall TZCryptMainFrm::SelDstBtnClick(TObject *Sender)
{
  if(!OpenDialog1->Execute()) return;
  DstFile->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------

